// List.h: interface for the CList class.
// template-s tmb mindenkinek...nem mintha nem lenne ilyen
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIST_H__8CC578E8_C45C_4683_A531_B463FCA6FAFD__INCLUDED_)
#define AFX_LIST_H__8CC578E8_C45C_4683_A531_B463FCA6FAFD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "d3dheaders.h"

template <class T>
class CList  
{
public:

	CList()
	{
		Array=NULL;
		ElemNumMax=0;
	};

	CList(int elemnum)
	{
		Array=NULL;
		CreateEmpty(elemnum); // ha sikerl akkor j ha nem akkor feltltskor tuti szopacs (mivel nem lehet ret true)
	};


	~CList()
	{
		KillData();
	};

	void KillData()
	{
		if(Array) 
		{
			try
			{
				delete[] Array;
				Array=NULL;
			}
			catch(...)
			{
				Array=NULL;
			}
		}
		ElemNumMax=0;

	};

	// res tmbt csinl (dumpos)
	bool CreateEmpty(int elemnum)
	{
		if(ElemNumMax==elemnum && Array) return true; // ha pont ekkora akkor maradhat nem?

		KillData();

		if(elemnum<0 || elemnum>10000000) return false;	
		if(!elemnum) return true; // ha nulla elem az is ok
	
		try
		{
			Array = new T [elemnum];
		}
		catch(...)
		{
			Array = NULL;
		}

		if(!Array) return false;
		ElemNumMax = elemnum;
		return true;
	}

	// kezdeti inic ezzel
	bool operator=(int elemnum)
	{
		return CreateEmpty(elemnum);
	}
	
	// vagy ezzel is lehet inic 
	bool operator=(CList<T>& Masik)
	{
		if(!CreateEmpty(Masik.ElemNumMax) && Masik.ElemNumMax>0) return 0; // mem error
		int i;
		for(i=0;i<Masik.ElemNumMax;i++) Array[i]=Masik.Array[i];
		return true;
	}

	// memcpy-s verzi (ha a class<T> memberjei kztt nincs din mem, ha van T::opeartor= akkor ez veszlyes lehet) 
	// nem rdmes hasznlni
	bool CopyNotDin(CList<T>& Masik)
	{
		if(!CreateEmpty(Masik.ElemNumMax) && Masik.ElemNumMax>0) return 0; // mem error
		if(Masik.ElemNumMax) memcpy(Array,Masik.Array,sizeof(T)*Masik.ElemNumMax);
		return true;
	}

	// bemsolja fromoffset-tl a tmbt ha lehet 
	// vagy bvti ha nem fr bele
	// ret : false -> nem sikerlt
	// IsDin =ha 0 akkor memcpy, ha 1 akkor operator= vel msol
	bool CopyIn(CList<T>&Masik,int fromoffset,char IsDin=1) // WARNING, ugly code ahead!
	{
		if(fromoffset<0 || fromoffset>1000000) return false; // nana
		int size = fromoffset+Masik.ElemNumMax; // ennyi elemnek muszj lennie
		if(size>ElemNumMax) // csinljunk j tmbt
		{
			T* old = Array; // ha van benne valami ne vesszen el.
			int oENM = ElemNumMax;
			Array=NULL; // ha nem null a CreateEmpty felszabadtja
			if(!CreateEmpty(size)) return false; // mem error
			// van kinullzand rsz ha a fromoffset a picsba mutat az elemnummaxhoz kpest
			int tozero=fromoffset-oENM;
			ZeroArrayPart(oENM,tozero); // nincs ell mert nem kell

			if(!IsDin && old)	// lehet kicsit tlzs ez a rsz de taln gy gyorsabb
			{
				memcpy(Array,old,sizeof(T)*oENM);
			}
			else
			{
				for(int i=0;i<oENM;i++) Array[i]=old[i];
			}
			if(old) delete[]old;
		}

		// na akkor msoljuk be az jat is hamr azrt van ez az egsz
		if(!IsDin)
		{
			memcpy(&Array[fromoffset],Masik.Array,sizeof(T)*Masik.ElemNumMax);
		}
		else
		{
			for(int i=0;i<Masik.ElemNumMax;i++) Array[fromoffset+i]=Masik.Array[i];
		}
		return true;
	}

	// kinullzza a tmb egy rszt
	bool ZeroArrayPart(int start,int elemnum)
	{
		if(start>=ElemNumMax || (start+elemnum)>ElemNumMax || start<0 || elemnum<0) return false;
		memset(&Array[start],0,sizeof(T)*elemnum);
		return true;
	}

	// tmb s mrete
	T* GetArray(int *elemnum=NULL)
	{
		if(elemnum) (*elemnum) = ElemNumMax;
		return Array;
	}

	// elemek szma csak.. majd ha prot member lesznek akkor j ez..
	int GetNum()
	{
		return ElemNumMax;
	}

	// ltrehozza s bemsolja a cuccost
	bool CreateAndFill(T* array,int arraynum)
	{
		if(!CreateEmpty(arraynum)) return false;
		memcpy(Array,array,sizeof(T)*arraynum);
		return true;
	}

	// mekkora helyet foglal byte-ban
	int size()
	{
		return (sizeof(T)*ElemNumMax);
	}

	// kimsolja a tmb rtkeit a paramterbe
	// memcpy - val !!!
	void OutCopymem(T* array)
	{
		memcpy(array,Array,sizeof(T)*ElemNumMax);
	}

	T* GetElem(int elemnum)
	{
		if(elemnum>=ElemNumMax) return NULL;
		return &Array[elemnum];
	}

// protected: - tl sok lenne az fv hvs, jobb kzvetlenl (de veszlyesebb is)
	T* Array;
	int ElemNumMax;
};

#endif // !defined(AFX_LIST_H__8CC578E8_C45C_4683_A531_B463FCA6FAFD__INCLUDED_)