// PLANE.h: interface for the PLANE class.
// egy skot r le az (A,B,C,D) formban
// ahol az ABC a sk normja, a D meg a sk negtv tvolsga az origtl
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PLANE_H__CB409B0C_68D2_440B_A8AC_77D3159A6551__INCLUDED_)
#define AFX_PLANE_H__CB409B0C_68D2_440B_A8AC_77D3159A6551__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "consts.h"
#include "cpphead.h"
#include "VECTOR.h"	

#define PLANE_IS_EQUAL_WHEN_CLOSER SMALLEST_VAL

class PLANE  
{
public:
	bool IsEQUAL(PLANE& ezzel,float smallv);
	int IsAllFrontVector(VECTOR* vec,int vecnum);
	VECTOR ProjectPoint(VECTOR* point);
	void ShiftPlaneVEC(VECTOR* vec);
	double GetDistDouble(VECTOR *vec);
	double TheAranyD(VECTOR *start, VECTOR *end);
	void ShiftPlane(float value);
	float TheArany(VECTOR*  start,VECTOR* end);
	bool PointOnPlane(VECTOR* pont);
	void Make(VECTOR* trivec);
	void Neg();
	bool operator ==(const PLANE &masik);
	void Make(VECTOR* pointonplane,VECTOR* planenormal);
	float GetDist(VECTOR* vec);
	void Make(float a,float b,float c,float d);
	void Make(const VECTOR &masik,float dd);
	VECTOR GetNormal();
	float A;
	float B;
	float C;
	float D;
	PLANE() {};
	PLANE(const VECTOR &masik,const float dd): A(masik.x),B(masik.y),C(masik.z),D(dd) 
	{}
	PLANE(float ax,float ay,float az,float ad) : A(ax),B(ay),C(az),D(ad)
	{}
};

#endif // !defined(AFX_PLANE_H__CB409B0C_68D2_440B_A8AC_77D3159A6551__INCLUDED_)
