#include "aabb.h"


// 3 hoszbl aabb (a teljes tgla mreteit kell megadni!!) - orgiot megadva el is tolja..
// ofset-hozzadja az oldalhosszokhoz - security offset (!)
void Caabb::Call_1_GenerateAABB(float xlen,float ylen,float zlen,float ofset,tAABB* out,VECTOR *neworigo)
{
	float x,y,z;
	x=xlen/2.f;
	y=ylen/2.f;
	z=zlen/2.f;
	out->minmax[0]=-x-ofset;
	out->minmax[1]=-y-ofset;
	out->minmax[2]=-z-ofset;
	out->minmax[3]= x+ofset;
	out->minmax[4]= y+ofset;
	out->minmax[5]= z+ofset; // min maxok
	if(neworigo)
	{
		VECTOR *ofset=(VECTOR*)out->minmax;
		ofset[0]+=(*neworigo);
		ofset[1]+=(*neworigo);
	}

}

// elvgja a vektortmbt az aabb-vel s ha kell vissza is adja a maradkot, 
// return : hny pont maradt benn
int Caabb::CutVecWithAABB(float *aabb, VECTOR *vec, int vecnum, VECTOR *OUTvectors)
{
	int i,u;
	char ofs[]={0,1,2,0,1,2}; // koordinta ofset
	VECTOR *p1,*p2,line;
	float ko1,ko2,theco,arany,cohosz;

	VECTOR va[MAX_VERTEX_FOR_POLIGON+6],vb[MAX_VERTEX_FOR_POLIGON+6];
	VECTOR *vinput,*voutput;
	char change=0;

	vinput=vec;voutput=vb; // szoksos tmbcsere pointerekkel
	int vinnum=vecnum,voutnum=0;

	for(i=0;i<6;i++) // mind a hat oldalra..
	{
		voutnum=0; // maradk pontok szma
		theco=aabb[i]; // a skot alkot koordinta min x,y,z max x,y,z

		for(u=0;u<vinnum;u++)
		{
			p1=&vinput[u];
			if(u<(vinnum-1)) p2=&vinput[u+1]; else p2=&vinput[0]; // a szakasz megvan
			ko1=((float*)p1) [ofs[i]] - theco;
			ko2=((float*)p2) [ofs[i]] - theco; // az aabb oldalnak megfelel koordinttk (tvolsgok a vgsktl)
			// na most az els hromnl a nagyobb kook vannak benn a msodik 3 nl a kisebbek
			if(i<3)
			{
				if(ko1>0.0f) // 1 pont a  vgsik eltt..(benn)
				{
					voutput[voutnum++]=(*p1);
					// msodik
					if(ko2>=0.0) continue; // majd..
					// vgni kell:
					cohosz=ko2-ko1;
					if (cohosz==0.0f) continue;
					arany=(-ko1)/cohosz;
					if (arany==0.0f) continue;
					line=(*p2)-(*p1); // majd ezt daraboljuk
					voutput[voutnum++]=(*p1)+line*arany;
					continue;
				}
				if(ko1==0.0f) {voutput[voutnum++]=(*p1);continue;} // spec eset
					// msodik
					if(ko2<=0.0f) continue; // kinn van vagy a skon akkor majd nzzk.
					// vgni kell:
					cohosz=ko2-ko1;
					if (cohosz==0.0f) continue;
					arany=(-ko1)/cohosz;
					if (arany==0.0f) continue;
					line=(*p2)-(*p1); // majd ezt daraboljuk
					voutput[voutnum++]=(*p1)+line*arany;
					continue;
				// ------- kinn ----------

			}
			else // bell most ha a koordinta kisebb..(maximumok ellenrzse)
			{
				if(ko1<0.0f) // 1 pont a  vgsik eltt..(benn)
				{
					voutput[voutnum++]=(*p1);
					// msodik
					if(ko2<=0.0f) continue; // majd..
					// vgni kell:
					cohosz=ko2-ko1;
					if (cohosz==0.0f) continue;
					arany=(-ko1)/cohosz;
					if (arany==0.0f) continue;
					line=(*p2)-(*p1); // majd ezt daraboljuk
					voutput[voutnum++]=(*p1)+line*arany;
					continue;
				}
				if(ko1==0.0f) {voutput[voutnum++]=(*p1);continue;} // spec eset
					// msodik
					if(ko2>=0.0f) continue; // kinn van vagy a skon akkor majd nzzk.
					// vgni kell:
					cohosz=ko2-ko1;
					if (cohosz==0.0f) continue;
					arany=(-ko1)/cohosz;
					if (arany==0.0f) continue;
					line=(*p2)-(*p1); // majd ezt daraboljuk
					voutput[voutnum++]=(*p1)+line*arany;
					continue;
				// ---------- kinn rsz ----------------
			}
		} // minden vektorra (u)

		// cserljk meg a tmbket (csak a pointerket input=output output=input!)
		if(!change) // kezdeti llapot volt 
		{
			vinput=vb;voutput=va;change=1;
		}
		else
		{
			vinput=va;voutput=vb;change=0;
		}
		vinnum=voutnum; // ennyi pont maradt, most ennyi lesz a kiindulk szma

	} // minden oldalra (i)

	if(OUTvectors)
	{
		memcpy(OUTvectors,vinput,voutnum*sizeof(VECTOR));
	}
	return voutnum;
}



// visszaadja a polik szmt (esetleg indext),ami az aabb-ben van
int Caabb::Call_3_GetPolisinBox(tAABB *aabb,CIList<int>* output)
{
	return callgetpolisinbox(aabb,output);
}

// return : mennyi poli volt benne...
int Caabb::callgetpolisinbox(tAABB *aabb,CIList<int>* output)
{
	if (output) output->ElemNum=0;
	clevel palya;
	int counter=0,i,ofset,vnum,u,ujvnum;
	VECTOR pv[MAX_VERTEX_FOR_POLIGON]; // egy poli vektora
	VECTOR* v=(VECTOR*)palya.coodinate.Array;

	for(i=0;i<palya.polis.ElemNumMax;i++)
	{
		// i a poli szma
		ofset=palya.polis.Array[i].vertexindex;	// honnan kezddnek a vektorai
		vnum=palya.polis.Array[i].vertexnum;	// poli vertex adatai
		if(vnum>MAX_VERTEX_FOR_POLIGON || vnum<3) return -1; // hibs poliadat...
		for(u=0;u<vnum;u++) pv[u]=v[ofset+u];
		ujvnum=CutVecWithAABB(aabb->minmax,pv,vnum,NULL);
		if(ujvnum)
		{
			if(output) output->AddElement(i);
			counter++;
		}
	}
	return counter;
}
