/*
Na ez az a file amiben minden benne van, a tbbi csak sallang.
*/

#include "collide.h"

/* ---------------------------------------------------------------------
			CPBody is itt van -elllt egy aabb adatszerkezetet
   ---------------------------------------------------------------------*/	

// inic: aabb-fle tmb a testem...hogy dalbl idzzek
int CPBody::Call_1_Start(float xz, float y,float stephi)
{
	createcollsioncube(xz,y);

	if(stephi>1.f) // abszolt lett megadva ? HIBA - mondjuk nem biztos, amilyen kicsik itt a mretek
	{
		StepHeigh = stephi / y;
	}
	else StepHeigh = stephi;

	return 1;
}

// AABB -t hoz ltre csak poligonokbl (CW ramutat irnyba a face)
// xz - x s z mrete mert ngyzet alap hasbokat kezel csak (semmi rtelme nem lenne tglalap alapot venni)
int CPBody::createcollsioncube(float xz, float y)
{
	// skok ------------------------------
	planes=6;

	float normas[]=
	{ // itt a 6 norma
		0,0,-1,		// elre	+z
		1,0,0,		// balra	-x
		0,0,1,		// htra	-z
		-1,0,0,		// jobbra	+x
		0,-1,0,		// fel		+y
		0,1,0		// le		-y
	};

	int i,ofset;

	float hx=xz/2,hy=y/2,hz=xz/2;		// z==x !!
	float dist[]={hz,hx,hz,hx,hy,hy};	// origtl val tv negltja

	VECTOR norma;
	for(i=0;i<6;i++) 
	{ 
		ofset=i*3; 
		norma = VECTOR(normas[ofset],normas[ofset+1],normas[ofset+2]);
		planes.Array[i].Make(norma,dist[i]);
	}

	// aabb min max data
	// min x,y,z, max x,y,z is jobb it mint utna keresgetni valahol benne
	aabb.minmax[0]=-hx;
	aabb.minmax[1]=-hy;
	aabb.minmax[2]=-hz;

	aabb.minmax[3]=hx;
	aabb.minmax[4]=hy;
	aabb.minmax[5]=hz;

	// poligon vektorok -----------------------
	//				 0, 1, 2,  3,  4,  5
	float cotomb[]={hx,hy,hz,-hx,-hy,-hz};

	char index[]=
	{
		// +z oldal 
		0,1,2,	3,1,2,	3,4,2,	0,4,2,
		// -x oldal
		3,1,2,	3,1,5,	3,4,5,	3,4,2, 
		// -z oldal
		3,1,5,	0,1,5,	0,4,5,	3,4,5,
		// +x oldal
		0,1,5,	0,1,2,	0,4,2,	0,4,5,

		// +y oldal
		3,1,5,	3,1,2,	0,1,2,	0,1,5,
		// -y oldal
		0,4,5,	0,4,2,	3,4,2,	3,4,5,
	}; // pfuj

	VectorList.CreateEmpty(6*4);
	for(i=0;i<6*4;i++) 
	{
		ofset=i*3;
		VectorList.Array[i]= 
			VECTOR(cotomb[index[ofset]],cotomb[index[ofset+1]],cotomb[index[ofset+2]]);
	}

	return 1;
}



/*	*************************************************************
	* 	CPVolume class imps. - vgskok aabb-bl s a vgs		*	
	*************************************************************/

// static mert mindenhol kr lenne ltrhozni s sosem kell egyidben kett
CList<IL_VECTOR>	CPVolume::CutPoliVectors=0;	// hull-onknt vgott polik 
CList<L_int>		CPVolume::OriginalPoliNums=0;// polik szma (eredeti)
CList<LI_PLANE>		CPVolume::VolumePlanes=0;	// skok amikbe be kell vagdosni a polikat
char				CPVolume::ClassIsOn = 0;	// ok e minden
CList<VECTOR>		CPVolume::CutOutput1 = 0;	// bels hasznlatra vgskor
CList<VECTOR>		CPVolume::CutOutput2 = 0;	// e is
CList<VECTOR>		CPVolume::CutOutput3 = 0;	// ez is 		
CList<CIL_CLVP>		CPVolume::ClosestPoints=0;	// legkzelebbi pontok
SP_BI				CPVolume::SlidingPlane;		// csszsk
CList<float>		CPVolume::Movements=0;		// meddig mehet egy aabb oldal a mozgsi irnyba
CIList<VECTOR>		CPVolume::AllSlideNormals=0;// minden csszsk
//CIList<VECTOR>	CPVolume::SPpoints;//=0;		// csszskok pontjai amibl generltuk (zs megnzzk a vgn melyik a legklabb sk mind kzl)
COLLPLANE			CPVolume::TheSLplane;		// csszskok pontjai amibl generltuk
COLLPLANE			CPVolume::NextPlane;		// segdje



// els pldnynl lefut utna mehet minden ha ok a progi vgig
void CPVolume::firstconstruct()
{
	ClassIsOn=0;

	const int	polinum=100,	// max vertex for cutpoli 
				volnum=CPV_MAX_VOLS,		// hny oldalnak lehet vg csve
				planenum=16,	// hny skja lehet egy vgcsnek max (6?)
				maxclosepointspervolume =128;	// max ennyi pont lehet ugyanolyan kzel egy skhoz
				
	if(!(CutPoliVectors=volnum)) return ;	// ennyi csnek lehet vgva poli
	if(!(OriginalPoliNums=volnum)) return;	// polinum-ok
	if(!(VolumePlanes=volnum)) return;		// ennyi oldalnak lehet konvex hullja sszesen
	if(!(ClosestPoints=volnum)) return;		// kzeli pontok
	if(!(TheSLplane.points=maxclosepointspervolume)) return; // skoat alkot pontok
	if(!(NextPlane.points=maxclosepointspervolume)) return; 

	if(!(Movements=volnum)) return;	
	if(!(AllSlideNormals=128))	return;		// minden cscssk normja

	int i;
	for(i=0;i<volnum;i++) 
	{
		if(!(VolumePlanes.Array[i]=planenum)) return ; // ennyi skja lehet egy oldalnak (nem csak 6 mert az aabb-ben lv polikat is nzni kk)
		if(!(CutPoliVectors.Array[i].CreateEmpty(polinum,polinum*8,0))) return;	// ennyi polija lehet egy csnek
		if(!(OriginalPoliNums.Array[i]=polinum)) return;	// a polik szma aminek nekimennek
		if(!(ClosestPoints.Array[i]=maxclosepointspervolume)) return;	// legkzelebbi pontok egy sknak aabb-ben

	}
	
	if(!(CutOutput1=CPV_MAX_VERTEX)) return;	
	if(!(CutOutput2=CPV_MAX_VERTEX)) return;	// ennyi lehet a vgott vertexek (vektorok) szma
	if(!(CutOutput3=CPV_MAX_VERTEX)) return;	

	ClassIsOn=1;	// minden ok
}

/*els tkzsvizsg eltt kell - minden frameben egy testnek meg kell hvni*/
void CPVolume::Call_before_movefirst()
{
	AllSlideNormals.ElemNum=0;
}


/*meg kell hvni mieltt indtunk egy tkzsvizsglatot*/
void CPVolume::Call_before_move(VECTOR* start,VECTOR* direction,float movelen)
{
	BoxMove.start=*start;
	BoxMove.direction=*direction;
	BoxMove.movelen=movelen;	
}


// elkszti a skokat,amikkel vghatunk oldalanknt..
// aabb - adatai start aabb pos (kzepe),dir mozgsi irny (!!NORMLT!!)
// len a mozgs hossza
void CPVolume::call_createcutplanes(CPBody* aabb,VECTOR* start,VECTOR* dir,float len)
{
	if(!ClassIsOn) return;	 // hiba

	VolumeNum=0;	// csvek szma
	aabbBody=aabb;	// adat eltrols

	int i;
	float dp;
	for(i=0;i<6;i++) // mely oldalak szmtanak:
	{
		dp = dir->DotProduct(*(VECTOR*)&aabbBody->planes.Array[i]);
		// skok befele nznek
		/*
			VIGYZAT: itt csak azrt lehet dp<0 mert a mozgsi irny mr meg lett
			vizsglva, hogy nagyon kis rtkek ne jhessenek ki (5. tizedesjegytl lefele akrmi kijhet)
		*/
		if(dp<0.f) 
		{
			AABBsides[VolumeNum]=i;	// mely oldal szerepelt
			createvolume(i,start,dir,len);	// ez nveli a VolumeNum-t !!
			VolumeNum++;
			if(VolumeNum>2) break; // max 3 oldal jtszhat
		}
	}

	
}


/*
megcsinlja az egy oldalnak megfelel vgcsvet:
sidenum : aabb oldala 0-5 
*/
void CPVolume::createvolume(int sidenum,VECTOR* start,VECTOR* dir,float len)
{


	if(VolumeNum>=CPV_MAX_VOLS) return; // viola szn nem l jl a proginak (access viola)
	if(sidenum<0 || sidenum>5) return;	// ez is 

	int planenum=0;
	PLANE pl;

	VECTOR n,*p1,*p2,*v = &aabbBody->VectorList.Array[sidenum*4];// adott aabb oldal 4 vektora megvan

	// back oldal: az aabb adott oldala: csak az aabb pos-ba kell tolni.
	pl = aabbBody->planes.Array[sidenum];

	pl.Neg();	// norml -

	pl.ShiftPlaneVEC(start);

	VolumePlanes.Array[VolumeNum].Array[planenum++]=pl;

	// front oldal (a cs vge a mozgsi irny szerinti vgpontban)
	pl=aabbBody->planes.Array[sidenum];

	pl.ShiftPlaneVEC(start);	// startpos

	n = (*dir)*len;
	pl.ShiftPlaneVEC(&n);	// mozgs hossza (2fv mert buta vagyok)

	VolumePlanes.Array[VolumeNum].Array[planenum++]=pl;

	int i;
	for(i=0;i<4;i++)
	{
		p1=&v[i];
		if(i<3) p2=&v[i+1]; else p2=&v[0];
		n = (*dir) * ((*p2)-(*p1));	// norma
		n.Normalize();	// black soup 'bottelnekk'

		pl.Make(p1,&n);	// sk
		pl.ShiftPlaneVEC(start); // eltols j origba

		VolumePlanes.Array[VolumeNum].Array[planenum++]=pl;
	}

	VolumePlanes.Array[VolumeNum].ElemNum=planenum;	// ennyi sk van benne

}


// kvetkez lps : polik belevgsa a skokkal hatrolt trrszekbe
//CutPoliVectors - vgott polik helye
/*
poligonok vgsa a csvekbe: 1-2-3 cs lehet max
VolumeNum - hny cs van
VolumePlanes - skok csvenkt
AABBsides[] eredeti oldalindex amibl a csvek vannak
CutPoliVectors - vektor- + indexlist a vgott vektoroknak * 3 minden csnek
OriginalPoliNums
*/

// polik vgsa csvekbe 
void CPVolume::cutpoligons()
{
	int i,u,pnum,vofset,vnum,pcou,plnum,remp;//,vecmax,indexmax;
	PLANE *planes,pl;
	VECTOR* v = (VECTOR*)Palya.coodinate.Array;
	for(i=0;i<VolumeNum;i++) // minden csre
	{
		CutPoliVectors.Array[i].Reset(); // adatok alaphelyzetbe

		// ne hvjunk fv-ket minden polira ha nem muszj <FIXME>? - nem annyira 
		pcou=0;
		planes=VolumePlanes.Array[i].Array;
		plnum =VolumePlanes.Array[i].ElemNum; // skok szma  
		for(u=0;u<Palya.polis.ElemNumMax;u++) // minden polira
		{
			pnum = u;	// poli szma
			vofset = Palya.polis.Array[pnum].vertexindex;
			vnum = Palya.polis.Array[pnum].vertexnum;		// poli vektorainak indexe

			pl.Make(&v[vofset]); // poli skjnak szmolsa
			
			// ha a mozgsi irnyra backface a poli akkor kitrdekel?
			if(BoxMove.direction.DotProduct(*(VECTOR*)&pl)>=0.0f) continue;
			remp = cutpoli(&v[vofset],vnum,planes,plnum,CutOutput3.Array);

			if(remp>0)
			{
				// na itt lehetne megsprlni az fv-t
				if(!CutPoliVectors.Array[i].Add(CutOutput3.Array,remp)) // nincs hely benne (jajaj)
				{
// game-nak annyi - buffer overflow
CWinInfo finito;finito.TerminateProgram=1;
					break;
				}
				OriginalPoliNums.Array[i].Array[pcou++]=pnum;
			}
		}
	}
}

// Sutherland-Hodge : here we go!
// belevgja a polit CutOutput1-CutOutput2 segedelmvel a skok kz
// pOutput != NULL akkor oda is bemsolja (mrete min CPV_MAX_VERTEX kell legyen!)
int CPVolume::cutpoli(VECTOR* pvec,int pvecnum,PLANE* planes,int planenum,VECTOR* pOutput)
{
	int s,i;
	PLANE sik; 
	int vi_num,vo_num;
	VECTOR *inv,*outv;	// pointeres cserebere
	char change=0;		// melyik pointer melyikre mutat csere: 0 outv=inv s ford.
	inv=pvec;vi_num=pvecnum;
	outv=CutOutput2.Array;
	VECTOR *p1,*p2,v,cutp;
	float dpa,dpb,dpc,arany;

	for(s=0;s<planenum;s++)
	{
		sik=planes[s]; // akt. sk ezzel vgunk
		vo_num=0;
		for(i=0;i<vi_num;i++) // --------minden poli lre
		{
			p1=&inv[i];
			if(i<vi_num-1) 	p2=&inv[i+1]; else p2=&inv[0];// megvan a kt pont az let kztte vgjuk

			dpa=sik.GetDist(p1);
			dpb=sik.GetDist(p2);

			if(dpa>0.0f) // 1. pont a sk eltt van m!
			{
				outv[vo_num++]=*p1;
				// msodik hol van
				if(dpb>0.0f) continue; // az is benne van akkor mehet tovbb..
				// vgs
				v=(*p2)-(*p1);
				dpc=v.DotProduct(sik.A,sik.B,sik.C);
				if(dpc==0.0f) arany=0.0f;else arany=(-dpa)/dpc;
				outv[vo_num++]=(*p1)+v*arany; // a metszspont
				continue;
			}

			// dpa<=0.0f akkor ---------
			if(dpb<=0.0f) continue; // 2. is mgtte van
			v=(*p2)-(*p1);
			dpc=v.DotProduct(sik.A,sik.B,sik.C);
			if(dpc==0.0f) arany=0.0f;else arany=(-dpa)/dpc;
			outv[vo_num++]=(*p1)+v*arany; // a metszspont
			//continue;
		} // minden lre---------------
		
		// most cserljk meg a tmbmutatkat az input lesz az output s fordtva
		if(!change) // inv volt az input (vagy az fv param..)
		{
			change=1;
			inv=CutOutput2.Array;
			outv=CutOutput1.Array;
		}
		else // fordtva
		{
			change=0;
			inv=CutOutput1.Array;
			outv=CutOutput2.Array;
		}
		vi_num=vo_num; // amennyi vektor keletkezett, annyi megy tovbb...


		if(!vo_num) break; // ha nem maradt akkor ne fontoskodjon (Arial pl:) tovbb
	} // minden skra

	// vge a vgsnak output :

	if(vo_num>CPV_MAX_VERTEX) return 0; // hiba tl sok pont

	if(pOutput)
		memcpy(pOutput,inv,vo_num*sizeof(VECTOR)); // vgeredmny
	return vo_num;
}



/*	minden volume -ra keressk meg a legkzelebbi pontot, aminek nekimegy
	ez elg egyszer mert aabb esetn ezek csak a megfelel koordintk klnbsge (x,y,vagy z)
	ezutn azt is ki kell okumullni, hogy ez a pont egy len van-e vagy a poli belsejben
	(ezt vgskor is ki lehetne mutatni s letrolni rjttem hogy az se lesz gyorsabb gyhogy kln lesz) 

*/

/* 
	akkor minden aabb skra nzzk meg mely pontok vannak a legkzelebb, letroljuk azokat,
	mely poli, valamint, hogy len vannak-e (akkor az leket is)
	esetleg poli sarokpontok-e (ez mind mind coll-responsnl kellenek majdan)

CList<IL_VECTOR>	CPVolume::CutPoliVectors=0;	// hull-onknt vgott polik 
CList<L_int>		CPVolume::OriginalPoliNums=0;	// polik szma (eredeti)
CList<L_PLANE>		CPVolume::VolumePlanes=0;	// skok amikbe be kell vagdosni a polikat
CList<int>			CPVolume::VolumePlaneNum=0;	// hny sk van egy csben - itt ugye lehet 6-8-ig
char				CPVolume::ClassIsOn = 0;	// ok e minden
CList<VECTOR>		CPVolume::CutOutput1 = 0;	// bels hasznlatra vgskor
CList<VECTOR>		CPVolume::CutOutput2 = 0;	// e is
CList<VECTOR>		CPVolume::CutOutput3 = 0;	// ez is 		
CList<CIL_CLVP>		CPVolume::ClosestPoints=0;	// legkzelebbi pontok
*/

// legkzelebbi tkzsi pontok keresse (ClosestPoints - feltltse)
// boxpos - hol van az aabb (*start lt)
void CPVolume::collectclosestpoints()
{
	if(!ClassIsOn) return; // nem kell menni

	int i,u,k,vnum;//,cou;

	// aabb minmax nak koord eltolva origbl
	float minmax[6]; memcpy(minmax,aabbBody->aabb.minmax,6*sizeof(float));
	for(i=0;i<2;i++) ((VECTOR*)minmax)[i]+=BoxMove.start;	// tols pos-ba

	// mely koordinta jtsza a tvolsgot
	int sidecoordindex[] = {2,0,2,0,1,1}; // z,x,z,x,y,y - ilyen sorrendben vannak az aabb lapjai
	// mely koordintkat kell nzni adott aabb lap index mellett
	int minmaxcoord[] = {5,0,2,3,4,1};	// +z, -x, -z, +x, +y, -y a sorrendje az aabb-nek !
	int c_ofs;	// 0-x,1-y,2-z 

	CIndexList<VECTOR>* l;
	float *f;
	VECTOR *v;
	float abco,min,tav;

	for(i=0;i<VolumeNum;i++) // minden csre
	{
		l = &CutPoliVectors.Array[i]; // vgott polivektorok s szmuk per poli
		
		c_ofs = sidecoordindex[AABBsides[i]]; // x,y,z-t kell-e nzni (0,1,2)

		min=MinDist[i]=BIG_FLOAT;	// legkisebb tv a csben - adott tengely mentn

		abco=minmax[minmaxcoord[AABBsides[i]]];	// a koordinta (x,y,z amitl nzni kell a pontok megfelel (x,y,z) co-jt)

		ClosestPoints.Array[i].ElemNum=0;	// szmll

		v	 =  l->Lump.Array; // folymatosan nvekszik az elejtl
		f	 =	&((float*)v)[c_ofs];

		for(u=0;u<l->IndexNum;u++) // minden benne lv polira
		{
			vnum =	l->Index.Array[u];

			for(k=0;k<vnum;k++)	// poli minden pontjra
			{
				// nzzk kzelebb van-e
				tav = abco - *f;
				if(tav<0.f) tav = -tav;

				if(tav<(min+PICI_FLOAT))	// talltunk egy minimumkzeli lmnyt (pontot)
				{
					// nzzk meg nem csak kb kisebb (volt mr ilyen pont - polik kzs llel szindrma)
					if(tav<(min-PICI_FLOAT)) // 'sokkal' kisebb
					{
						// a tbbi, ami eddig volt nem kell...ez lesz a legkisebb 'etalonja'
						ClosestPoints.Array[i].ElemNum=1; // az j elem van benne
						ClosestPoints.Array[i].Array[0].point=*v;		// vektor
						ClosestPoints.Array[i].Array[0].cutpolinum=u;	// cutpoli indexe
					}
					else	// a tv olyan kicsi amilyen mr van..  tegyk ezt is be
					{
						// mg belefr, <opti> a sok indexet
						if(ClosestPoints.Array[i].ElemNum < ClosestPoints.Array[i].ElemNumMax)	
						{
							int elemnum = ClosestPoints.Array[i].ElemNum++; // az j elem van benne
							ClosestPoints.Array[i].Array[elemnum].point=*v;		// vektor
							ClosestPoints.Array[i].Array[elemnum].cutpolinum=u;	// cutpoli indexe
						}
					}
					if(tav<min) min = tav; /// <FONTOS!>
				}

				f+=3;	// kvetkez vektor adott x,y,z eleme (3 floattal odbb)
				v++;	// a vektor
			}// minden vertexre
		}// minden polira

		MinDist[i] = min; 



	}// minden csre

	getclosestvolumes();
	verifychecks();	// ld lejjebb vgott pontok helyzete az eredeti poliban
}

/*
Hopp innen meg a nagy szilveszteri eljszakn maj kifelejtettem, hogy az oldalak
kztti minimumokat az elmozdulsi vektoron kell nzni, nem abszolte,
s azokbl a legkisebbek gyznek... ugym - csak koordintatengelyekre kell vetteni a mozgsi irnyt(hosszal)
s az megadja 0-1 kztti arnnyal mennyit mehet a teljes tvval
m- lesz az arny
*/

// szal ez azokat a csveket gyjti ki ahol a legkevesebb az elmozduls
void CPVolume::getclosestvolumes()
{
	int i;
	VECTOR n,maxmove;
	float maxtav,m,min = 1000000000.0f;
	MinMovementDistance=0.f;	// ennyit fog elmozdulni a doboz

	maxmove = BoxMove.direction * BoxMove.movelen;	// ennyit mehet max

	for(i=0;i<VolumeNum;i++)
	{
		n = *((VECTOR*)&aabbBody->planes.Array[AABBsides[i]]);
		n.neg();

		maxtav	= n.DotProduct(BoxMove.direction)*BoxMove.movelen; // ennyi a max elmozduls adott tengelyen
		m = MinDist[i] / maxtav;	// ez az arnyuk ==1 akkor nem tkzik
		if(m>1.f) m=1.f;

		if(m<0.f) 
		{
			// itt is 'vgzetetes' hiba trtnt - jobban is lehet kezelni azrt ...
			CWinInfo finito;finito.TerminateProgram=1;
		}
		Movements.Array[i] = m;
		// az igazsg az, hogy 0<=m<=1.0f nek kellene lennie
		if(m<min) min = m;
	}

	MinMovementDistance = min;	// a legisebb tv

	/*
		most azokat a csveket amelyek messzebb tkznek, ki kell ejteni,
		mert kit rdekel, hogy a horizonton beakad valamibe ha fal van az orra eltt 
		a msikban.
	*/

	for(i=0;i<VolumeNum;i++) 
	{
		m = Movements.Array[i];	// cstv minimum 0-1

		if(!FLOAT_EQ(m,min,PICI_FLOAT)) // ha nem kb a minimum akkor csak nagyobb lehet (kb: tweak it to me...)
			ClosestPoints.Array[i].ElemNum=0; // nincs eleme tbb :((((
	} 
}

/*
collectclosestpoints kigyjttte csvenknt a pontokat amik legkzelebb vannak
ez meg megnzi, hogy a  pontok az eredeti poli belsejben, az ln vagy esetleg
vmelyik cscsuk.
eztun csak azokat kell vizsglni ahol a ClosestPoints.Array[i].ElemNum >1 mert kiejti a tvoliakat
*/
void CPVolume::verifychecks()
{
	
	int i,u,pnum,vofset,vnum;
	CIL_CLVP	*l=NULL;
	int			*opn=NULL;
	CLV_POINT	*ps=NULL;

	for(i=0;i<VolumeNum;i++) // minden csre
	{
		l   = &ClosestPoints.Array[i]; // vgott polivektorok s szmuk per poli

		if(l->ElemNum<1) continue;	// lsd fejjebb
		opn = OriginalPoliNums.Array[i].Array;	// eredeti poligonindexek a bsp-ben (szmuk)
		
		for(u=0;u<l->ElemNum;u++) // minden legkzelebbi pontra
		{
			ps		= &l->Array[u];		// adott hitpoint adatstruct
			pnum	= opn[ps->cutpolinum];	// eredeti poliindex
			vofset	= Palya.polis.Array[pnum].vertexindex;
			vnum	= Palya.polis.Array[pnum].vertexnum;	// vektorok kezdete s vge a nagy lump-ban
			// lvizsglat
			ps->posinpoli = 
				IsEdge(&((VECTOR*)Palya.coodinate.Array)[vofset],vnum,&ps->point,&ps->egde[0],&ps->egde[1]);

		}
	}
}

// normlsok vannak benne !!!! jujujujjujujuj!
/*
 poli ln van e a point 
 ret 0 - benne van e1=e2=VNULL !!!
 ret 1 - len van  e1=p1,e2=p2 az l!
 ret 2 - poli egyik sarka a pont (kb) e1=p1=VNULL
*/
int CPVolume::IsEdge(VECTOR* polivec,int pvecnum,VECTOR *point,VECTOR* e1,VECTOR* e2)
{
	if(pvecnum<3) return -1;	// hiba
	int i,pn=pvecnum-2; // htultesztels miatt nem -1 hanem -2 azrt mert vltskor mg nem 
						// n az i (0 amikor pl az els van s 2 amikor az utls van quad-nl)

	VECTOR *p1=polivec,*p2=&polivec[1],edge,v,final;
	double t,hossz;
	if(e1) *e1=VNULL;
	if(e2) *e2=VNULL;



	for(i=0;i<pvecnum;i++)
	{
		edge = (*p2)-(*p1);
		v = (*point) - (*p1);	// p1 a relatv orig
		hossz = edge.DotProduct(v) / (edge.DotProduct(edge));	// v vettse edge-re ha ~0 vagy 1 akkor a poli sarka !!!

		edge=edge*hossz;// edge-en a point kpe (merleges : diszkrt cos trans asszem)

		final = v-edge;	// merleges az edge re s hossza az edge egyenes s v pont tvja

		t = final.Normalize(); // ha ez nulla-fle, akkor oks


		if(t<PICI_FLOAT) // AKKOR EZ MOST SAROK VAGY L !!
		{
			if(hossz<PICI_FLOAT || FLOAT_EQ(hossz,1.f,PICI_FLOAT)) // sarokpont(besarok mingy)
			{
				return 2;	
			}
			if(e1 && e2) {*e1=*p1;*e2=*p2;}
			return 1;
		}

		p1++;
		if(i<pn) p2++; else p2=&polivec[0];	// utols + els pont
	}

	return 0;
}

/*
most akkor jhet a sliding-plane szmols
ClosestPoints - adathalmazbl.
	thesis:
		az els pont ki lett vve, mert a tbbi autmatikusan megoldja (nem kell)
		- ha tbb pont van egy aabb sknak egyenl tvolsgban (min3),
			s ezek koordinti klnbznek (nem 2 poli l tallkozsnl keletkezik 2 pl)
			akkor a csszsk az aabb lapja lesz 
		- ha sima pont van a  poli belsejben (tul az aabb egy sarkval rinti egy poli felsznt)
			akkor a poli skja a csszsk
		- ha a legkzelebbi pont len van, akkor az llel s az t elvg aabb oldalal (2 vektor)
		  crossprod-tal lehet skot csinlni.
		- ha poli sarokpontjnak tkzik, s a fenti esetek egyike sem ll fenn (az els),
			akkor az aabb skjn csszik (el az egsz kb.)
	Menet:
		1. nzzk van-e olyan oldal, ahol a legkzelebb van az tkzsi pont (ezt lehetett volna hamarabb is)
			mert akkor a tbbivel nem kellene foglalkozni.
*/

// csszskok generlsa
void CPVolume::slidingplanes()
{
	// 1 tbb pont azonos tvra
	int i,vnum,pnum,u;
	CIL_CLVP	*l=NULL;
	int			*opn=NULL;
	CLV_POINT	*ps=NULL;
	VECTOR		v1,v2,v3,n,*pvec=(VECTOR*)Palya.coodinate.Array;
	PLANE		sik;
	char sign;

//	SlidingPlanes.ElemNum=0;	// nulla sk van
	SlidingPlane.posinpoli=-1;	// nincs benne semmi
	TheSLplane.Reset();
	NextPlane.Reset();

	SP_BI pldata;
	

	for(i=0;i<VolumeNum;i++)
	{
		l = &ClosestPoints.Array[i];
		if(l->ElemNum<1) continue;	// nincs benne relevns pontocska

	// ------------- ha nincs aabb sk akkor nzzem mr meg, hogy van-e poli-beli pont-----
		sign=0;
		for(vnum=0;vnum<l->ElemNum;vnum++)
		{
			if(!l->Array[vnum].posinpoli)
			{
				sign=1;
				// na lehet ez a kt sor nem tl evidens
				int erdeti_index = OriginalPoliNums.Array[i].Array[l->Array[vnum].cutpolinum];
				sik.Make(&pvec[Palya.polis.Array[erdeti_index].vertexindex]);
				pldata.plane = sik;

				pldata.posinpoli = 0;
				pldata.volumeindex = i;
				// itt elg a pont vagy a poli minden sarka kne?
				NextPlane.planedata=pldata;
				drop_farplanes(&TheSLplane,&NextPlane,l);
				break;
			}

		}

		if(sign) continue;

	// -------------- ha se 3 pont se polibeli pont nincs akkor tn len van egy? -----------------
		for(vnum=0;vnum<l->ElemNum;vnum++)
		{
			if(l->Array[vnum].posinpoli==1) // len tncol
			{
				// na most jn az lkivtel: ha valamely vgskhoz kzel van, akkor bels pontnak szmt
				if(!NotEgde(&l->Array[vnum].egde[0],&l->Array[vnum].egde[1],&VolumePlanes.Array[i]))
				{
					sign=1;
					// csinljuk meg a skot abbl az oldalbl ami az let vgta s az l vektorbl.
					// de melyik is vgta (ezt is le lehetett volna trolni de mindennek van hatra!)
					// amelyik skhoz legkzelebb van a pont annak nzzk a vektorait ()
					// 0<=pnum<=3 mert a front back oldalt nem nzi 
					pnum = closestplane(&l->Array[vnum].point,&VolumePlanes.Array[i]); // cs sk szma
					// most akkor a vektorok, amikbl kpzdtek.
					u = AABBsides[i]*4;
					v1 = aabbBody->VectorList.Array[u+pnum];
					if(pnum==3) v2=aabbBody->VectorList.Array[u];
					else v2=aabbBody->VectorList.Array[u+pnum+1];
					// v1-v2 * l, meg is van a csszpln !! 
					v3=v1-v2;
					n = v3*(l->Array[vnum].egde[0]-l->Array[vnum].egde[1]); // lehet elg lett volna a klnbsget letrolni
					n.Normalize();	// do'h !!
					sik.Make(&l->Array[vnum].egde[0],&n);
				
					pldata.plane = sik;
					pldata.posinpoli = 1;
					pldata.volumeindex = i;

					NextPlane.planedata=pldata;
					drop_farplanes(&TheSLplane,&NextPlane,l);

					break; // nem kell tbbet nzegetni..
				}	// ha NotEdge szerint is neml !!
				else 
				{
					sign=1;	// ok 
					// akkor bels pont a poli skjn csszik
					int erdeti_index = OriginalPoliNums.Array[i].Array[l->Array[vnum].cutpolinum];
					sik.Make(&pvec[Palya.polis.Array[erdeti_index].vertexindex]);

					pldata.plane = sik;
					pldata.posinpoli = 0; // bels pont 
					pldata.volumeindex = i;

					NextPlane.planedata=pldata;
					drop_farplanes(&TheSLplane,&NextPlane,l);

					break; // nem kell tbbet nzegetn
				}

			}	// ha l !!

		}	// for

		if(sign) continue;

		// ---------------------------------------------------------------------
		// akkor itt az utols eset, ha egyik se akkor
		// csak van egy legkzelebbi pont a neki tkz oldal skja cssztat
		// mondjuk itt 3 am kor eszembe jut hogy mi van ha 2 merleges skra is kijn .. akkor nulla lesz a vetlet lehet
		// ha arra vettjk amelyik a hosszabbat adja (dotpr-je kisebb) az ok?
		// eddig minden zsr nem kne itt elszrni.. tn...
		// ---------------------------------------------------------------------
		for(vnum=0;vnum<l->ElemNum;vnum++)
		{
			if(l->Array[vnum].posinpoli==2) // ponton nyugszik
			{
				sign=1;
				sik.Make(&l->Array[vnum].point,(VECTOR*)&aabbBody->planes.Array[AABBsides[i]]);

				pldata.plane = sik;
				pldata.posinpoli = 2; // ?
				pldata.volumeindex = i;

				NextPlane.planedata=pldata;
				drop_farplanes(&TheSLplane,&NextPlane,l);

				break; // nem kell tbbet nzegetni..
			}

		}		
		
		if(sign) continue;

	} // i<VolumeNum

	if(TheSLplane.planedata.posinpoli>-1) 
	{
//		SlidingPlanes.AddElement(TheSLplane.planedata);	
		SlidingPlane = TheSLplane.planedata;
//logger.log("sli plane ",&SlidingPlane.plane);
//logger.log("posinpoli ",SlidingPlane.posinpoli);

	}
}

/*
ez csinlja azt, hogyha egy sk pontjai mgtte van (mind) egy msiknak
akkor kiejti ezt - mert ksbb tkzne neki - lst pl kis vlyn tcsszs esete...ttmarival :)
a second skjt megfordtja ha htrafele van.
ha nincs els (first->planedata.posinpoli<0) akkor automatikusan a msodik lesz az els
kivlogatja a msodik skjhoz tartoz pontokat, s azokat sszeveti az els skjval (mely oldalon vannak)
ha mind a hta meget vala, akkor marad az els, ha nem akkor megnzi az els pontjait,
nincsennek-e a msodik mgtt (mind) akkor az els kiesik s a msodik lesz a nyertes .. huh.
ret = 1 ha volt csere
*/
int CPVolume::drop_farplanes(COLLPLANE* first,COLLPLANE* second,CIL_CLVP* closestps)
{
	
	// kis kitr, hogy tbb legyen a jsg: fordtsuk meg a nzni kvnt skot, ha elfele nz
	// mert akkor rossz lesz az eltte-mgtte dolog... a csszsnak meg ugye mindegy.
	// az elst nem kell mert vagy rvnytelen, vagy mr megvolt ez (secondbl lett)
	if(second->planedata.plane.GetDist(&BoxMove.start)<0.0f) second->planedata.plane.Neg();

	// ellenrzsek, valamelyik nem degenerlt-e, mert akkor nem kell sszevetni
	if(first->planedata.posinpoli<0)
	{
		if(second->planedata.posinpoli<0) 
		{
			logger.log("<error> CPVolume::drop_farplanes mindegyik sk rossz!! (vol1)");
			return 0;
		}
		else 
		{
			(*first) = (*second);
			return 1;
		}
	}
	if(second->planedata.posinpoli<0)
	{
		if(first->planedata.posinpoli<0) 
		{
			logger.log("<error> CPVolume::drop_farplanes mindegyik sk rossz!! (vol2)");
			return 0;
		}
		else 
		{
			return 0;
		}
	}

	// 1 lps minden pont kigyjtse az jnak..
	int i,emax=second->points.ElemNumMax;
	PLANE *pl=&second->planedata.plane;
	second->points.ElemNum=0;
	VECTOR*v;

	for(i=0;i<closestps->ElemNum;i++)
	{
		v=&closestps->Array[i].point;
		if(FLOAT_EQ(pl->GetDist(v),0.f,PICI_FLOAT)) // kb rajta van
		{
			if(!second->points.AddElement(*v)) 
			{
				logger.log("<error> CPVolume::drop_farplanes, too many points..");
				break; // nem fr be a tmbjbe annyira sok pont van - error lehet..
			}
		}
	}

	// 2 csekk: nzzk ezek a pontok nincsennek e mind az first skja mgtt
	pl=&first->planedata.plane;
	if(getpos_dist(pl,&second->points,PICI_FLOAT))	// van az els eltt msodikbl pont
	{
		if(!getpos_dist(&second->planedata.plane,&first->points,PICI_FLOAT))  // els minden pontja a msodik mgtt van : csere
		{

			(*first) = (*second);
			return 1;
		}
		// krds, hogy eztn, errefele mi is van... mert ekkor mindegyik j ... de melyik maradjon
		// itt elvileg azt kellene tudni melyikkel tudja folytatni majd az utat .. ez nonsense
	}
	// marad a rgi
	return 0;
}

// megnzi van-e olyan pont ami a sk eltt van (szrssal persze)
int CPVolume::getpos_dist(PLANE* sik,CIList<VECTOR>* pontok,float pici)
{
	int i;
	VECTOR*v=pontok->Array;
	float tav;

	for(i=0;i<pontok->ElemNum;i++)
	{
		tav = sik->GetDist(v);
		if(tav>pici) // ezek szerint eltte van, return true
		{
			return 1;
		}
		v++; // lpdeccsnk a vektorokon
	}
	return 0;
}

/*
ha ide jut a protzi, akkor fenll egy jabb spec eset, miszerint
mindegyik sknak van olyan pontja ami a msik sk eltt tallhat	
ilyenkor megint mi a helyzet... nemtom
*/

/*
ez fv azrt kell mert pl egy falhoz rve, ha a padln ll s vzszinesen mozog,
elfordul, hogy a fggleges poli als lt ltkzsnek detektlja 
(ha benne maradt volna a slidingplanes()-ben a hrom pont ellenrzs akkor nem)
ezrt meg kell nzni, a keletkezett l nincs-e vmely vgskon rajta, mert akkor csak sima
bels pont.
*/

// megnzi, hogy nem esik-e egy vgskra az l mert akkor nem is l
// ha egy skra esik akkor ret =1
// vigyzni kell mindenhol, hogy 2 els sk kimaradjon, klnben bugzik - hibs kihagy j leket s megakad.
int CPVolume::NotEgde(VECTOR* edge1,VECTOR* edge2,LI_PLANE* sikok)
{

	int i;
	PLANE* p=&sikok->Array[2]; // VIGYZAT
	float d1,d2;

	// FONTOS ! az eljel klnbzik akkor metszi az lt akkor nem kell kivenni
	// VIGYZAT
	for(i=2;i<sikok->ElemNum;i++) // front-back oldalt nem kell nzni a csben (az csak a vgshoz kellett)
									// csak a 4 oldalt
	{
		d1 = p->GetDist(edge1);if(d1<0) d1=-d1;
		d2 = p->GetDist(edge2);if(d2<0) d2=-d2;

		if(d1<PICI_FLOAT && d2<PICI_FLOAT) 
		{
			return 1;
		}

		p++; // next sk
	}
	return 0;
}

// ponthoz legkzelebbi sk vlasztsa - valszeg az a sk vgott egy lt, amin kijtt e pont
// na azt az lt kk megtallni.
// az els kettt (front-back) nem nzi mert azok csak ne vgjanak leket lehetleg (minimumban)
// ret index
int CPVolume::closestplane(VECTOR* pont,CIList<PLANE>* planes)
{
	int i,min=2;	// taln az als sk lehetne az alap
	float md,dist = 100000000.0f;

	for(i=2;i<planes->ElemNum;i++)
	{
		md = planes->Array[i].GetDist(pont);
		if(md<dist) {dist=md;min=i;}
	}
	return min-2;
}
/*
megjegyzs a tbb sk, mint kolbsz esethez:
extrm esetben kijhet, hogy ugyanolyan messze
vannak pontok 2 sktl is, ekkor megakadhat a mozgs.
ezt az esetet nem jrtam mg krl, a tesztprogiban 
egyszer se sikerlt mg sszehozni, ha valakinek mgis prolm
lenne belle, akkor egy spec esetknt kellene vizsglni, s a kt(v hrom)
olyan skot, amik benne vannak (aabb oldalak) normit kellene sszeadni majd tlagolni
az j lehet.... ha kell ez egyltaln - doboz sarka tkzik csccsal elvileg ilyenkor
*/

/*
hamr megvan a sk s az is meddig mehet max 
akkor csak el kell mozgatni s nzni mennyi marad.
remanencia - ennyit s erre mozoghat mg
return amennyit ment (relatv to start)
valamint itt nzi meg lehet-e fellpni esetleg..
ha igen akkor nem kell a mozgs irnyt megvltoztatni..
*/
VECTOR CPVolume::movetoend(VECTOR* remdir,float* remlen,VECTOR *stepvec)
{
	if(stepvec) *stepvec=VNULL;

	// MinMovementDistance -ennyit mehet el arnyban
	/*
		vigyzni kell, hogy ne a relatv (0-1) szorzbl vonjuk ki a biztonsgi 
		tvolsgot, hanem az elmozduls abszolt hosszbl
	*/

	float movlen = BoxMove.movelen*MinMovementDistance; // ez a tv amit megtehet (absz.)
	movlen		-= PICI_FLOAT ;	// biztonsg kedvrt ne menjen olyan messze

	if(movlen<PICI_FLOAT) movlen = 0.f;

	float	move_len_now = movlen, //BoxMove.movelen * MinMovementDistance,	// ennyit mehet most
			move_len_next = BoxMove.movelen - move_len_now;			// ennyi maradt

	VECTOR	move	= BoxMove.direction * move_len_now,			// ennyit mehet most
			newdir	= BoxMove.direction * move_len_next;		// ezeket kell a skokra lekpezni
	// akkor vettsk a skokra
	PLANE hupsz;
	char was_stepup = 0;	// volt-e fellps (lpcsre, sznpadon)

	if(SlidingPlane.posinpoli>-1) // van sk
	{
		hupsz = SlidingPlane.plane;
		hupsz.D=0;	// mivel a newdir is az origbl indul ki a sk is legyen az origban 
					// (ha messze lenne valahol, akkor elg rdekes sebessg s irnyvltsok lennnek)
		newdir =  hupsz.ProjectPoint(&newdir); // 

	// ha a sk meredek s nem bels pontbl szrmazik (mert akkor a poli skjn csszik)
	// valamint nem fggleges csben keletkezett akkor megprblhat fellpni.
	// akkor lpjen (prblja meg) ha a poli meredekebb mint 60 fok(y=1 tl mrve COS(30) ) ,nem negtv a norma y-ja s nem az als oldal vgta meg
	// viszont lehet a pontinpoli - ne legyen bels pont nem kell mert bugzik - sima lpcsfokoknl
	
		// prbljunk fellpni
		if(SlidingPlane.plane.B<0.5f && SlidingPlane.plane.B>=0.f && AABBsides[SlidingPlane.volumeindex]<4)
		{
			VECTOR pos=BoxMove.start+move;
			if(suggest_steppin(&pos,stepvec)>0.f) // fellphet, van hely
			{
				// ------- ha fel lehet lpni valamire akkor a mozgsi irny marad -------------
				*remdir = BoxMove.direction;
				// - trljk az y irny elmozdulst, hogy ne nzzen tovbbra is pl nagyon le
				// mert akkor ismt nekimenet az lnek... s meg is akadhat a mozgs
				remdir->y=0.f; remdir->Normalize();
				*remlen = move_len_next; // irny s sebessg marad a rgi mert ha fellptnk akkor tul nem mentnk semminek
				was_stepup = 1;		// volt fellps
			}
		}
	} // volt sk

	// nem tudott fellpni, ekkor a 
	// csszskra lekpezett irnyt s maradk tvot kell tovbbvinni
	if(!was_stepup) 
	{

		*remdir =  newdir;//st2-st1;						// irny
		*remlen = (float)remdir->Normalize();	// hossz
	}

	// ha keveset mozdult s mg sok van akkor sk feltltse, ha mozgott akkor skok rtse
	if(move_len_now<PICI_FLOAT)
	{
		if(move_len_next>PICI_FLOAT) 
		{
			uploadplanes();
		}
		
	}
	else AllSlideNormals.ElemNum=0; // elmozdult nem kellenek a rgebbi skok (j ez gy..ha min 3 szor ellenriz akkor igen)
	return move;
}

/* sszegyjt minden csszskot arra az esetre, ha megakadna (pl negatv dls falaknl),
	s megprbl mindezzel valamit kezdeni .../-) 
	ha kt sk van szmoljunk a 2 normllal normt s az lesz az irny - osz szeva (ezen filztam picit)	
*/
void CPVolume::uploadplanes()
{
	float dp;
	int u,ch;
	VECTOR n;

	n=*(VECTOR*)&SlidingPlane.plane;
	ch=1;

	for(u=0;u<AllSlideNormals.ElemNum;u++)
	{
		dp = AllSlideNormals.Array[u].DotProduct(n);
		if(dp>(1.f-PICI_FLOAT/10) || dp<(-1-PICI_FLOAT/10)) {ch=0;break;}
	}
	if(ch) AllSlideNormals.AddElement(n);
}

// LPCS
// megnzi, tud-e fellpni a vektor mondja meg hova is lenne rdemes 
// boxpos: hol akadt meg a doboz (start), stepadd: ha felugorhat valahova 
// ez az RELATV ELMOZDULS ahova -> boxpos+stepadd = ide kell fellpnie
// return: ha 0.f akkor nem ugrik, amgy a tallt max magassg
// amgy ha elmozd bl lesz j seb akkor az ugrst le kell majd vonni mert egy lpcsfok is elreptheti (1 milisec alatt 1 m Y elm nagy sebessg lesz..)
float CPVolume::suggest_steppin(VECTOR* boxpos,VECTOR* stepadd)
{
	int i,u,nostep=1;
	*stepadd=VNULL;

	float maxy=-BIG_FLOAT;	
	float d,ply=aabbBody->aabb.minmax[1]+boxpos->y;	// ez az aabb padljnak y-ja

	CLV_POINT* point;
	for(i=0;i<VolumeNum;i++) // minden csre
	{
		if(AABBsides[i]>3) continue; // elvileg ekkor le is llhatnnk..
		point = ClosestPoints.Array[i].Array;
		for(u=0;u<ClosestPoints.Array[i].ElemNum;u++)
		{
			d=point->point.y-ply; // mennyire van feljebb a pont az aabb padljtl
			if(d>maxy) {maxy=d;nostep=0;} // talltunk legnagyobbat, s rdemes tovbbnzni
			point++;
		}
	}
	
	if(nostep) return 0.0f;	// nem volt pont, ekkor maxy an k*rva kis rtk van ezzel tovbbmenni ksz ngyilkossg (-10 milli mtert lefele lpni...hmm)

	float maxHI = aabbBody->aabb.minmax[4]-aabbBody->aabb.minmax[1]; // doboz magassga

	maxHI *= aabbBody->StepHeigh;	 // ennyire tud fellpni (abszolte)
	if(maxHI<maxy) return 0.0f;	// nem kell fellpni tl magas

	// fellpsi vektor
	VECTOR step = BoxMove.start;step.y+=(maxy+PICI_FLOAT); // picit feljebb is kne menni, ne menjen esetleg megint neki

	int pnum = trystep(&step);
	if(pnum) return 0.0f;
	*stepadd = step-BoxMove.start;// csak a pos megvlt rtke kell.
	return maxy;
}

// fel tud-e lpni 
int CPVolume::trystep(VECTOR* ide)
{
	tAABB aabb;
	aabb = aabbBody->aabb;
	aabb.translate(ide);
	int pnum=aabbTest.Call_3_GetPolisinBox(&aabb,NULL); // hny poli van a dobozban
	return pnum;
}

/**************************************************************
	Ccollide - funct
 **************************************************************/

Ccollide::Ccollide()
{
	pCollBody=NULL;
}

Ccollide::~Ccollide()
{

}

/*
ez mozgatja a dobozt ameddig lehet, majd Output- ban visszatr, hogy mennyit mozdult el 
(Output->start), merre menjen legkzelebb (Output->direction),mennyit (Output->movelen)
a start neve hibs de nem ide lett a struct csinlva, de ide is j.- csak flrevezet 
de az fv ugyis protected nemigaz hahaha
*/
void Ccollide::Movebox(VECTOR *start,VECTOR *direction,float movelen,CC_MOVE* Output,
					   VECTOR *stepup)
{
	*stepup=VNULL;

	VolumeCut.Call_before_move(start,direction,movelen);

	// -------------- oldallapokbl csvek : --------------

	VolumeCut.call_createcutplanes(pCollBody,start,direction,movelen);

	// -------------- vgs minden csbe ------------------ 
	VolumeCut.cutpoligons();

	// -------------- legkzelebbi pontok gyjtse csveknnt -------------
	/*
		belltja 
		ClosestPoints - minden csben a legkzelebbi pontok gyjtemnye (tbb is lehet )
		MinDist[]	  - minimum tvolsgok minden csnek a normljn vve az elmozdulst
		---
		getclosestvolumes() fv :
		Movements	  - kiszmolja 0-1 arnyban mennyit mehet egy cs szerint az aabb
					  - majd kiejti (ClosestPoints...ElemNum=0) azokat a csveket amikben messzebb lehet menni
		verifychecks() fv:
		ClosestPoints - tbbi rsze : ltkzs stb belltsa
	*/

	VolumeCut.collectclosestpoints();

	// --------------- csszskok ellltsa ----------------

	/*
		Kiszmolja a csszskokat
		tbb is lehet adott esetben ezek megegyezhetnek (norma lehet ellenttes)
		<SlidingPlanes>
	*/

	VolumeCut.slidingplanes();

	// -------------- elmozduls -------------------------------

	Output->mennyitmegy=VolumeCut.movetoend(&Output->ujdir,&Output->rem_movelen,stepup);

}


/// NA EZT KELL HVNI !!!

// elmozdtja az aabb-t s visszaadja, MENNYIT MOZDULT EL !!!.
// steps ben vannak azok az elmozdulsok sszegezve ami nem mens csszs,
// hanem fellpsbl jtt ssze, ezeket sebessgszmtsnl le kell vonni. (ha az elm mtrkbl lesz az j mozgsi seb.)
VECTOR Ccollide::Call_1_MOVE(CPBody* pBody,VECTOR *start, 
							 VECTOR *direction,float movelen,VECTOR* steps)
{
	*steps=VNULL;

	// biztonsgi ellenrzsek
	if(fabs(start->x)>NONSENSE_FLOAT || fabs(start->y)>NONSENSE_FLOAT ||fabs(start->z)>NONSENSE_FLOAT) return VNULL;
	if(fabs(direction->x)>NONSENSE_FLOAT || fabs(direction->y)>NONSENSE_FLOAT ||fabs(direction->z)>NONSENSE_FLOAT) return VNULL;
	if(fabs(movelen)>NONSENSE_FLOAT || fabs(movelen)<PICI_FLOAT) return VNULL;


	if(!pBody) return VNULL;
	// adatfelvtel
	pCollBody = pBody;	// testi adatok megvannak

	/*
		az elmozduls vektort figyelni kell, ha egy x,y,z komponense nagyon kicsi
		- 7 tizedesjegy alatt brmi lehet (pontatlansg)
		ezrt ezt a szemetet ki kell venni ne generljon egy degenerlt vgcsvet
		(ott kiszrni veszlyes - mert akkor msfele mozog, mint amerre ellenriz)
	*/
	VECTOR ujdir = *direction;	// most egy kis javts

	float* co=(float*)&ujdir;
	for(int i=0;i<3;i++) if(FLOAT_EQ(co[i],0.0f,LIKE_NULL)) co[i]=0.f; // minden vektorkomponensre

	// ha nulla lett a vektor akkor szeva
	if(FLOAT_EQ(ujdir.Normalize(),0.f,LIKE_NULL)) return VNULL;

	VECTOR st_add,move=*start,dir=ujdir;
	float len=movelen;

	// els mozgatsi kr.
	movecycle(&move,&dir,&len,steps); // pos, irny,hossz,output>fellpsek (sszegezve)

// jabb prba ha nem ment vgig akkor beakadt a ferdefal effektusba?
	if(len>PICI_FLOAT*10) 
	{
		dir = final_cring(&dir); // ha volt kt sk akkor van j irny
		if(!dir.IsZero()) // Do'H ! mgegyszer az egszet ... htha
		{
			movecycle(&move,&dir,&len,steps);
		}
	}
	return (move-(*start));
}

// ez vgez egy mozgatsi krt megprbl move bl move+dir*len be elmozdulni,
// ha tkzik, akkor csszik, 
// a move,dir,len output is,valamint steps tartalmazza az sszes fellps menyisgt 
void Ccollide::movecycle(VECTOR *move,VECTOR* dir,float* len,VECTOR* steps)
{
	// tesztelsre beragadt-e
	tAABB testaabb;
	CC_MOVE output;
	VECTOR st_add=VNULL;	// fellpsek 

	int i,pnum;

	VolumeCut.Call_before_movefirst();	// skok begyjtse inic.

	for(i=0;i<4;i++) 
	{
		Movebox(move,dir,*len,&output,&st_add);

		(*move)+=output.mennyitmegy;	// elmozduls hozzadsa
		(*move)+=st_add;				// fellpst is hozz kell adni
		(*steps)+=st_add;				// fellpsek nyilvn tartsa

		// teszt, nem ragadt-e be
		testaabb = pCollBody->aabb;
		testaabb.translate(move);
		pnum = aabbTest.Call_3_GetPolisinBox(&testaabb);
		if(pnum)
		{
			// ha ide kerl akkor beragadt - elvileg vissza kellene tolni az 
			// utols olyan pozciba, ahol nem volt beragadva
			// csakhogy ez sose ragad be !!! (ha jl hasznljk)
			// nekem legalbbis a tesztek sorn egyszer se sikerl beakasztani - minden ms eljtt
		}

		(*dir) = output.ujdir; 
		(*len) = output.rem_movelen;
		if(*len<PICI_FLOAT) break; // ha mr nagyon kevs, akkor ne mozogjon flslegbe
	}
}

/*
akkor itt van taln az uts problm(bugokat leszmtva), ha negatv dlsszg fallal
tallkozik:
	1. padl skjra vetl a mozgsi  irny (pl y 0 lesz)
	2. ferde fal -y-t csinl s nem megy sehova mert ugye ott a pall van
	s ez megy milliszor akr de nem mozdul el az 'ittenek' se.
	ez szinte brmilyen laposszg helyzetben elfordulhat... s el is fog.
	hogy is kk megoldani...
	
	a. eltrolni az sszes skot,amikor nem volt nagy mozgs (skok gyjtse)
	b. ... ?????? - mr lertam vagy tzszer : a skok normjval j normt szmolni (vektorilis szorzat)
*/
// itt is van
// return az irny amerre tn lehet
VECTOR Ccollide::final_cring(VECTOR* dir)
{
	VECTOR ret,atl=VNULL;
	if(VolumeCut.AllSlideNormals.ElemNum<1) return VNULL; // nincs sk, akkor ennyi 

	VECTOR *v=VolumeCut.AllSlideNormals.Array,newway;
	newway=v[0]*v[1];
	if(dir->DotProduct(newway)<0) newway.neg();
	newway.Normalize();
	return newway; 
}

// Csak ennyi lenne - csak 1300 sor s elmozdul A pontbl B-be.. de llat! ;)



