/*
	Ez az ktzsvizsglatot vgz rsz. 
	3 osztlya van:
		CPBody		- az tkzsi aabb ltrhozsa s fenntartsa (csak egyszer kell ltrehozni)
		CPVolume	- ez vgzi a f tkzsvizsglatot, kezdve a polik vgstl a csszskok ltrehozsig
		Ccollide	- ezt kell konkrtan hvni a vizsglathoz, ez mkdteti a CPVolume-ot tbbszr is meghvva
*/

#if !defined(AFX_COLLIDE_H__15265E4A_F7C0_4275_B846_FA93D964710F__INCLUDED_)
#define AFX_COLLIDE_H__15265E4A_F7C0_4275_B846_FA93D964710F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "log.h"
#include "cpphead.h"
#include "aabb.h"
#include "list.h"
#include "VECTOR.h"
#include "PLANE.h"
#include "IndexList.h"
#include "CIList.h"
#include "WinDraw.h"

typedef CIndexList<VECTOR>	IL_VECTOR;	// vektortmbre indexel szolgltats
typedef CList<PLANE>		L_PLANE;	// skok listja
typedef CList<int>			L_int;		// int lista

#define PICI_FLOAT	(1.f/1024.f)	// kis rtk - ennl kisebb klnbsgek a geometriban nem szmtanak
#define BIG_FLOAT   10000000.f		// legkisebb keressnl kell
#define NONSENSE_FLOAT   1000000.f  // ha ennl nagyobb jn ki az nem klassz, egyltaln nem (!)

// VATOSAN, ITT EL LEHET CSE.. RONTANI KNNYEN, HOGY MIT VLASZTOK!!
#define LIKE_NULL	(PICI_FLOAT/1.f)	// olyan pici, hogy mr nulla - /1000 mr nem j 

// megadva neki egy x,y,z hosszt elllt egy aabb-t
// s a sarok koordintit
// egy test polijai, face normljai - adatosztly
class CPBody
{
public:
	CPBody(){memset(&aabb,0,sizeof(tAABB));};
	int Call_1_Start(float xz, float y,float stephi);

	// polik szma == normalok szma v VectorList.indexek szma
	CList<PLANE>planes;		// skok tmbje (el kell tolni ha az aabb is elmozdul)
	CList<VECTOR>VectorList; // vektorok 6*4 - ennek semmi rtelme lehet
	tAABB	aabb;
	float StepHeigh;	// 0-1 milyen magasra tud fellpni (abszolt a test magassgnak arnyban)
protected:
	int createcollsioncube(float xz, float y);	// aabb inic
	Clog logger;
};

// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------

#define CPV_MAX_VOLS 3	// hny cs lehet egy aabb nek max
#define CPV_MAX_VERTEX	10	// max hny vertexe lehet egy vgott polinak

struct CLV_POINT
{
	VECTOR point;	// pont coord
	int posinpoli;	// 0 poliban 1 edge,2 sarokpont
	VECTOR egde[2];	// ha l akkor itt van az l kt vge
	int cutpolinum; // bevgott poli indexe (eredeti kinyerhet a OriginalPoliNums-bl)
};

struct CLV_MOVE		// egy doboz mozgatsi krelme adatok
{	
	VECTOR start;
	VECTOR direction;
	float  movelen;	
};

struct CC_MOVE		// j mozgs
{	
	VECTOR mennyitmegy;
	VECTOR ujdir;
	float  rem_movelen;	
};

// tmbdef
typedef CIList<CLV_POINT>	CIL_CLVP;
typedef CIList<PLANE>		LI_PLANE;

// csszsk s hogy mely cs csinlta 
// s mibl esetbl jtt ltre (CLV_POINT::posinpoli | 3 -3pont esete )
struct SP_BI
{
	PLANE plane;
	int volumeindex;
	int posinpoli;

	SP_BI& operator=(SP_BI& masik)
	{
		plane=masik.plane;
		volumeindex=masik.volumeindex;
		posinpoli=masik.posinpoli;
		return *this;
	};

	void Reset()
	{
		plane=PLANE(0,0,0,0);
		volumeindex=0;
		posinpoli=-1;
	};
};

/*
ebbe trolja slidingplanes() a skot amit tallt, meg a rajta lv vektorokat.
eztn hasonltja ssze a kvetkezvel s az marad benn, akinek a msik minden pontja
mgtte vagy rajta van. (tvolabbi sk)
*/
struct COLLPLANE
{
	SP_BI planedata;
	CIList <VECTOR>	points;

	COLLPLANE& operator=(COLLPLANE& ezzel)
	{
		planedata = ezzel.planedata;
		points = ezzel.points;
		return *this;
	};
	void Reset()
	{
		planedata.Reset();
		points.ElemNum=0;
	};
};


// az osztly mely a vagdosst vgzi..max 3 oladalra ugye egy aabb-nl
class CPVolume
{
friend class Ccollide;
protected:

	CPBody* aabbBody;						// az aabb amibl a vgskok lesznek
	static char ClassIsOn;					// ha ez 1 akkor minden tmb ksz, mehet a menet
	static CList<IL_VECTOR> CutPoliVectors;	// hull-onknt vgott polik 
	static CList<L_int>		OriginalPoliNums;// eredeti polik szma ami a CutPoliVectors-ba kerlt
	static CList<LI_PLANE>	VolumePlanes;	// skok amikbe be kell vagdosni a polikat
	static CList<VECTOR>	CutOutput1;		// bels hasznlatra vgskor /cutpoli()/
	static CList<VECTOR>	CutOutput2;		// ez is
	static CList<VECTOR>	CutOutput3;		// detto
	static CList<CIL_CLVP>	ClosestPoints;	// minden csben a legkzelebbiek (tbb is lehet sajna)
	static SP_BI			SlidingPlane;	// csszsk
	static COLLPLANE		TheSLplane;		// csszskok pontjai amibl generltuk
	static COLLPLANE		NextPlane;		// ez tmeneti trol de nem kne azrt 1000 szer ltrehozni mp-knt ugye

	static CList<float>		Movements;		// mennyit mehetnek egyes oldalak a koordinta tenglyen
	static CIList<VECTOR>	AllSlideNormals;// minden csszsk normlja arra az esetre ha beakadnnk (teszt)

	int		VolumeNum;				// hny cs van amivel vgunk
	int		AABBsides[CPV_MAX_VOLS];// mely csvek jtszanak (lt 3*[0-5])
	float	MinDist[CPV_MAX_VOLS];	// minimum tvok a csvekben	
	float	MinMovementDistance;	// a legkisebb elm. ennyit fog elmozdulni (0-1)
	CLV_MOVE	BoxMove;			// start move dir movelen...
	Caabb	aabbTest;				// poligon-in-da-box

	clevel Palya;					// sszes poli adata
	// ---------------- fggvnyek ---------------

	CPVolume() 
	{
		aabbBody=NULL;
		if(!ClassIsOn) 
		{
			firstconstruct();
			if(!ClassIsOn)
			{
				// hiba? akkor kilps
				CWinInfo finito;finito.TerminateProgram=1;
			}
		}
	};
	~CPVolume() {};
	void Call_before_movefirst();
	void Call_before_move(VECTOR* start,VECTOR* direction,float movelen);

	int getpos_dist(PLANE* sik,CIList<VECTOR>* pontok,float pici);
	int drop_farplanes(COLLPLANE* first,COLLPLANE* second,CIL_CLVP* closestps);
	void uploadplanes();
	void call_createcutplanes(CPBody* aabb,VECTOR* start,VECTOR* dir,float len);
	void cutpoligons();
	void createvolume(int sidenum,VECTOR* start,VECTOR* dir,float len);


	int trystep(VECTOR* ide);
	float suggest_steppin(VECTOR* boxpos,VECTOR* stepadd);
	int NotEgde(VECTOR* edge1,VECTOR* edge2,LI_PLANE* sikok);
	VECTOR movetoend(VECTOR* remdir,float* remlen,VECTOR *stepvec);
	void getclosestvolumes();
	void collectclosestpoints();
	int closestplane(VECTOR* pont,CIList<PLANE>* planes);
	void slidingplanes();
	void verifychecks();
	int IsEdge(VECTOR* polivec,int pvecnum,VECTOR *point,VECTOR* e1,VECTOR* e2);
	int cutpoli(VECTOR* pvec,int pvecnum,PLANE* planes,int planenum,VECTOR* pOutput); // bels tmbbe vg..
	Clog logger;
	// ha mg soha nem volt hasznlva...
	void firstconstruct();
};

// ---------------------------------------------------------------------------------------------
// ez vgzi a mozgatst (megmondja hova meddig mehet)

class Ccollide // CPEngine  
{
public:
	Caabb aabbTest;
	VECTOR Call_1_MOVE(CPBody* pBody,VECTOR *start,VECTOR *direction, float movelen,VECTOR* steps);
	Ccollide();
	~Ccollide();
protected:
	void movecycle(VECTOR *move,VECTOR* dir,float* len,VECTOR* steps);
	VECTOR final_cring(VECTOR* dir);
	void Movebox(VECTOR *start,VECTOR *direction,float movelen,CC_MOVE* Output,VECTOR *stepup);
	CPBody* pCollBody;
	CPVolume VolumeCut;
	Clog logger;
};


#endif // !defined(AFX_COLLIDE_H__15265E4A_F7C0_4275_B846_FA93D964710F__INCLUDED_)
