/*
	DEMO projekt (Visual C++ 6 verzival kszle). 
	Fleki Pter 2007 februr.
	Dem clja tkzsvizsglat bemutatsa (swept aabb-vel)
	Figyelem:
		Ahogy manapsg senki, n se vllalok felelssget
		semmirt ezzel a programmal, vagy brmely tevkenysgvel 
		kapcsolatban,azaz a PROGRAM 'AS IS'.
	Mindeki hasznlja sajt felelsssgre, sajt beltsa szerint.
	A programkd nem lvez semmilyen vdelmet, a felhasznlst mindenkinek a
	lelkiismeretre bzom ha akar beletehet a ksznetnylvntsba.
	rmmel veszek minden javaslatot s szrevtelt: pjotrfu@freemail.hu
*/

#include "WinDraw.h"
#include "d3dDevice.h"

#include "camera.h"
#include "Texture.h"
#include "Draw.h"
#include "Level.h"
#include "KameraInput.h"
#include "collide.h"

#include "log.h"

// T.H.E...W-I-N-M-A-I-N !!!! - where ALLLLL the suck begins muhaha
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	// tesztelni j, logfile-ni j!
	Clog log;
	log.START(); // exe knyvtra letrolva, ide fog logolni
	log.logonoff(1); // loging bekapcs (0) kikapcs
	log.Reset();


	// alapadatok ablaknak
	int ok=1;
	int ablak_x=640,ablak_y=480;	// felbonts
	int ablakban_fut=0;				// full scr=0,ablak-1 

	// fusson-e ablakban
	if(MessageBox(NULL,"Inidts: ","Ablakban fusson? (res 640-480)",MB_YESNO)==IDYES) ablakban_fut=1;


	CWinDraw ablak; // ablak ltrhozsa
	Cd3dDevice dev;	// d3d inic.

	if(!ablak.Call_1_MakeWindow("demo",ablakban_fut,ablak_x,ablak_y,0)) 
	{
		MessageBox(NULL,"Nincs ablak!!","vge - HIBA",MB_OK);
		ok=0;
	}
	else
	{
		if(!dev.Call_InicDevice(ablak_x,ablak_y,ablakban_fut,ablak.GetWnd()))
		{
			MessageBox(NULL,"Direct3D9 indtsa sikertelen!!","vge - HIBA!",MB_OK);
			ok=0;
		}
	}

	// mehet a menet
	if(ok)
	{
		CWinInfo winmess;	// ablakzenetek + billentyzet
		CLevel Level;		// tesztplya betltse

		char levelname[]="level.bsp";
		if(!Level.Call_loadlevel(levelname)) 
		{
			MessageBox(winmess.AblakHandle,levelname,"Tesztplya betltse sikertelen/HIBA",MB_OK);
			exit(0); // s ksz is a baj
		}

		CDeviceInfo dev;	// d3d infok (device, scr size..)
		CDraw draw;			// ez rajzol

		// textrk betltse
		// ht nem egy 'betltsvezrl'.
		CList<CTexture> tex;tex=5; // nulladik textra nincs 
		tex.Array[1].Load("tex1.jpg",256);
		tex.Array[2].Load("tex2.jpg",256);
		tex.Array[3].Load("tex3.jpg",256);
		tex.Array[4].Load("tex4.jpg",256);

		VECTOR aabb_middle(0,5,0),dir(0,0,1);	// kezd pozci, kezd irny

		// kamera class s inic
		Ccamera Kam;
		Kam.Call_1_SetFrustrum(45.f,0.2f,100.f); // ltszeg
		Kam.Call_SetVECTORS(&aabb_middle,&dir);
		Kam.Call_MAKEVIEWMATRIX();				// view mtrix kiszmoltatsa
		Kam.Call_SETMATRIXtoGPU();				// belltsa 

		VECTOR hozzaad,step,mozg_ok;
		draw.SetWorldMatrix();					// world mtrix=egysgmtrix

		draw.CullMode(0);	// ramutatval egyez poligonsodrs rajzolsa lesz (clasic d3d)

		KameraInput KI;KI.Call_1_init(&Kam);	// kamerakezel osztly inic (ez forgat meg minden)
	
		float mozg_hossz;

		// ******************************************************
		// tkzsvizsglathoz kell cucc (ezekrt van minden)
		// ------------------------------------------------
		float magassag = 2;
		float szelesseg=1;
		CPBody		aabbtest;	// aabb-t tartalmaz class
		Ccollide	coll;		// ebben van a mozgats 
		aabbtest.Call_1_Start(szelesseg,magassag,0.3f); // magassg 3/10 edig tud fellpni
		// ******************************************************

		VECTOR pos; // fejmagassgnak

		MSG msg;
		while(1)
		{
			if(winmess.GetMeAMessage(&msg)==-1 || winmess.KEY[27]) break; // click bezrson,vagy esc
			
			pos = Kam.Get_eye();

			// kamera forgatsa
			KI.Call_2_loop(&msg);	
			// szabad replsnl a hozzad-ot kell hozzadni a pozcihoz
			hozzaad=KI.Call_flycamera(&pos,&Kam.Get_direction(),0.1f);

			// gravitvi - nem vve tlzsba a lekdolst :)
			hozzaad.y=0.0f;
			hozzaad.y-=0.05f;

			mozg_hossz=float(hozzaad.Normalize());	// elmozd hossza.
			// input adatok
			// 1 aabb ami mozog (aabbtest)
			// 2 aabb_middle ahonnan indul
			// 3 hozzaad az irny (normlt)
			// 4 mozg_hossz mozgs hossza
			// 5 output param: kzben ennyit lpett fel (benne van a visszaadott vektorban)
			// ret a veltor amennyit elmozdulhat
			mozg_ok = coll.Call_1_MOVE(&aabbtest,&aabb_middle,&hozzaad,mozg_hossz,&step);

			aabb_middle+=mozg_ok; // az j pozci

			// letszerbbnek hat, ha nem a testmag felnl van a szeme, hanem feljebb
			pos = aabb_middle;
			pos.y+=magassag/4;		// magassg 75% nl van a szem
			Kam.Call_SetPos(&pos);

			Kam.Call_MAKEVIEWMATRIX();
			Kam.Call_SETMATRIXtoGPU();


			dev.BeginFrame(0x0,3);	// frame inidtsa d3d-ben
			draw.DrawPalya(&Kam.Get_eye(),&Kam.Get_direction(),&tex); // plya kirajzolsa (minden poli) 
			dev.EndFrame();			// kp kirajzolsa az ablakba

		}

	}




	return 0;
}